#!usr/bin/env python
# -*- coding: utf-8 -*-

import web
import os
import re
from funciones import *
from datetime import *
from definiciones import *
from web import form

#configuracion
web.config.debug = False

#direcciones utilizadas
urls = (
  '/', 'index',
  '/publicar/','publicar',
  '/buscar/(.*)','buscar',
  '/cuentas/','cuentas'
)

#ubicacion del sitio template
render = web.template.render('templates/')

#pagina home
class index:
    def GET(self):
        ultimos=ultimos_articulos()
        recomendacion=recomendar_articulo()
        if recomendacion != dict():
            recomendacion["telefono"]=""
            recomendacion["email"]=""
            for data in obtener_cuentas():
                if data[0]==recomendacion["persona"]:
                    recomendacion["telefono"]=data[1]
                    recomendacion["email"]=data[2]
        return str(render.header("index",nombre,iconos_header))+str(render.home(nombre,slogan,ultimos,recomendacion))+str(render.footer())

#pagina para crear cuentas
class cuentas:
    def GET(self):
        data={"nombre":"","email":"","telefono":""}
        return str(render.header("cuentas",nombre,iconos_header))+str(render.cuentas(None,data))+str(render.footer())

    def POST(self):
        post_input = dict(web.input(_method='post'))
        if self.validar(post_input):
            crear_cuenta(tuple([post_input["nombre"],post_input["telefono"],post_input["email"]]))
            return str(render.header("cuentas",nombre,iconos_header))+str(render.postcuentas(post_input))+str(render.footer())
        else:
            return str(render.header("cuentas",nombre,iconos_header))+str(render.cuentas("error",post_input))+str(render.footer())

    def validar(self,post):
        return post["nombre"]!="" and post["email"]!="" and post["telefono"]!=""

#pagina para publicar articulos
class publicar:
    def GET(self):
        cuentas = obtener_cuentas()
        data = {"persona":"","nombre":"","descripcion":"","precio":"","tipo":""}
        return str(render.header("publicar",nombre,iconos_header))+str(render.publicar(cuentas,tipos_articulo,None,data))+str(render.footer())

    def POST(self):
        cuentas = obtener_cuentas()
        post_input = dict(web.input(_nethod='post'))
        del post_input["_nethod"]
        for llave,valor in post_input.items():
                post_input[llave]=str(valor)
        post_input["fecha"]=str(datetime.today()).split(" ")[0]
        if self.validar(post_input):
            print post_input
            publicar_articulo(post_input)
            return str(render.header("publicar",nombre,iconos_header))+str(render.postpublicar(post_input))+str(render.footer())
        else:
            return str(render.header("publicar",nombre,iconos_header))+str(render.publicar(cuentas,tipos_articulo,"error",post_input))+str(render.footer())


    def validar(self,post):
        persona = post["persona"]!="Seleccione una cuenta..."
        nombre = post ["nombre"]!=""
        descripcion = post["descripcion"]!=""
        precio = post["precio"]!=""
        tipo = post["tipo"]!="Seleccione un tipo..."
        return persona and nombre and descripcion and precio and tipo

#pagina para buscar articulos
class buscar:
    def GET(self,name=None):
        if name:
            filtro=filtrar_articulos(name)
            resultado=resultado_busqueda(filtro)
            for result in resultado:
                result["telefono"]=""
                result["email"]=""
                for data in obtener_cuentas():
                    if data[0]==result["persona"]:
                        result["telefono"]=data[1]
                        result["email"]=data[2]
                for llave in result:
                    if llave in ["nombre","persona","descripcion"]:
                        result[llave]=palabras_clave(name,result[llave])

            return str(render.header("buscar",nombre,iconos_header))+str(render.buscar(name,resultado,tipos_articulo))+str(render.footer())
        else:
            return str(render.header("buscar",nombre,iconos_header))+str(render.buscar(name))+str(render.footer())

#pagina no encontrada
def notfound():
    return web.notfound(str(render.header("index",nombre,iconos_header))+str(render.notfound())+str(render.footer()))

if __name__ == "__main__":
    app = web.application(urls, globals())
    app.notfound = notfound
    app.run()

